/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.59
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.48 2007/08/14 18:42:22 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.59 2008/04/23 13:56:20 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
78 80
79
80# this code is from linux-mod.eclass
81update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 81
103# New method of storing plugindb 82# New method of storing plugindb
104# Called from src_install 83# Called from src_install
105# file maintained by normal portage-methods 84# file maintained by normal portage-methods
106create_plugindb_file() { 85create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 88 insinto "${NEW_VDRPLUGINDB_DIR}"
89
90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 91# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 92# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 93# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 94# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 95# EBUILD_V=${PVR}
115 EOT 96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
116} 103}
117 104
118# Delete files created outside of vdr-plugin.eclass 105# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 106# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 107# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 108# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 110delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 111 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 114
128 # file exists 115 # file exists
129 [[ -f ${DB_FILE} ]] || return 116 [[ -f ${DB_FILE} ]] || return
130 117
131 # will portage handle the file itself 118 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 120 #elog file owned by eclass - don't touch it
134 return 121 return
135 fi 122 fi
136 123
137 elog "Removing orphaned plugindb-file." 124 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 125 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 126 rm "${DB_FILE}"
140} 127}
141 128
142 129
143create_header_checksum_file() 130create_header_checksum_file()
144{ 131{
145 # Danger: Not using $ROOT here, as compile will also not use it !!! 132 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway 133 # If vdr in $ROOT and / differ, plugins will not run anyway
147 134
148 insinto ${VDR_CHECKSUM_DIR} 135 insinto "${VDR_CHECKSUM_DIR}"
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
151 else 138 else
152 if type -p md5sum >/dev/null 2>&1; then 139 if type -p md5sum >/dev/null 2>&1; then
153 cd ${S} 140 cd "${S}"
154 ( 141 (
155 cd ${VDR_INCLUDE_DIR} 142 cd "${VDR_INCLUDE_DIR}"
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
157 ) > header-md5-${PN} 144 ) > header-md5-${PN}
158 doins header-md5-${PN} 145 doins header-md5-${PN}
159 fi 146 fi
160 fi 147 fi
161} 148}
162 149
150fix_vdr_libsi_include()
151{
152 einfo "Fixing include of libsi-headers"
153 local f
154 for f; do
155 sed -i "${f}" \
156 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
157 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
158 done
159}
160
161vdr_patchmakefile() {
162 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before
165
166 ebegin " Setting Pathes"
167 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::' \
174 -e 's:-I$(DVBDIR)::'
175 eend $?
176
177 # maybe needed for multiproto:
178 #sed -i Makefile \
179 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
180 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
181 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
182
183 if ! grep -q APIVERSION Makefile; then
184 ebegin " Converting to APIVERSION"
185 sed -i Makefile \
186 -e 's:^APIVERSION = :APIVERSION ?= :' \
187 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
188 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
189 eend $?
190 fi
191
192 # Correcting Compile-Flags
193 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
194 sed -i Makefile \
195 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
196 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
197
198 # Disabling file stripping, useful for debugging
199 sed -i Makefile \
200 -e '/@.*strip/d' \
201 -e '/strip \$(LIBDIR)\/\$@/d' \
202 -e '/@.*\$(STRIP)/d'
203
204 # Use a file instead of a variable as single-stepping via ebuild
205 # destroys environment.
206 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
207}
208
209vdr_add_local_patch() {
210 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
211 echo
212 einfo "Applying local patches"
213 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
214 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
215 done
216 fi
217}
218
219vdr_has_gettext() {
220 has_version ">=media-video/vdr-1.5.7"
221}
222
223plugin_has_gettext() {
224 [[ -d po ]]
225}
226
227vdr_i18n_convert_to_gettext() {
228 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
229
230 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
231 ewarn "Conversion to gettext disabled in ebuild"
232 return 1
233 fi
234
235 if [[ ! -x ${i18n_tool} ]]; then
236 eerror "Missing ${i18n_tool}"
237 eerror "Please re-emerge vdr"
238 die "Missing ${i18n_tool}"
239 fi
240
241 ebegin "Auto converting translations to gettext"
242 # call i18n-to-gettext tool
243 # take all texts missing tr call into special file
244 "${i18n_tool}" 2>/dev/null \
245 |sed -e '/^"/!d' \
246 -e '/^""$/d' \
247 -e 's/\(.*\)/trNOOP(\1)/' \
248 > dummy-translations-trNOOP.c
249
250 # if there were untranslated texts just run it again
251 # now the missing calls are listed in
252 # dummy-translations-trNOOP.c
253 if [[ -s dummy-translations-trNOOP.c ]]; then
254 "${i18n_tool}" &>/dev/null
255 fi
256
257 # now use the modified Makefile
258 if [[ -f Makefile.new ]]; then
259 mv Makefile.new Makefile
260 eend 0 ""
261 else
262 eend 1 "Conversion to gettext failed. Plugin needs fixing."
263 return 1
264 fi
265}
266
267vdr_i18n_disable_gettext() {
268 ebegin "Disabling gettext support in plugin"
269 # Remove i18n Target if using older vdr
270 sed -i Makefile \
271 -e '/^all:/s/ i18n//'
272 eend 0
273}
274
275vdr_i18n() {
276 if vdr_has_gettext; then
277 einfo "VDR has gettext support"
278 if plugin_has_gettext; then
279 einfo "Plugin has gettext support, fine"
280 else
281 vdr_i18n_convert_to_gettext
282 if [[ $? != 0 ]]; then
283 eerror ""
284 eerror "Plugin will have only english OSD texts"
285 eerror "it needs manual fixing."
286 fi
287 fi
288 else
289 einfo "VDR has no gettext support"
290 if plugin_has_gettext; then
291 vdr_i18n_disable_gettext
292 fi
293 fi
294}
295
296vdr-plugin_copy_source_tree() {
297 pushd . >/dev/null
298 cp -r "${S}" "${T}"/source-tree
299 cd "${T}"/source-tree
300 cp "${WORKDIR}"/Makefile.before Makefile
301 # TODO: Fix this, maybe no longer needed
302 sed -i Makefile \
303 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
304 -e 's:^CXXFLAGS:#CXXFLAGS:' \
305 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
306 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
307 popd >/dev/null
308}
309
310vdr-plugin_install_source_tree() {
311 einfo "Installing sources"
312 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
313 insinto "${destdir}-${PV}"
314 doins -r "${T}"/source-tree/*
315
316 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
317}
318
319vdr-plugin_print_enable_command() {
320 elog
321 elog "To activate this vdr-plugin execute the following command:"
322 elog "\teselect vdr-plugin enable ${PN#vdr-}"
323 elog
324}
325
326
327## exported functions
328
163vdr-plugin_pkg_setup() { 329vdr-plugin_pkg_setup() {
164 # -fPIC is needed for shared objects on some platforms (amd64 and others) 330 # -fPIC is needed for shared objects on some platforms (amd64 and others)
165 append-flags -fPIC 331 append-flags -fPIC
166 332
167 # Where should the plugins live in the filesystem 333 # Where should the plugins live in the filesystem
177 DVB_INCLUDE_DIR="/usr/include" 343 DVB_INCLUDE_DIR="/usr/include"
178 344
179 345
180 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 346 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
181 LOCDIR="/usr/share/vdr/locale" 347 LOCDIR="/usr/share/vdr/locale"
182 if has_version ">=media-video/vdr-1.5.7"; then
183 USE_GETTEXT=1
184 else
185 USE_GETTEXT=0
186 fi
187 348
188 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 349 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
189 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 350 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
190 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 351 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
191 352
192 einfo "Building ${PF} against vdr-${VDRVERSION}" 353 einfo "Compiling against"
193 einfo "APIVERSION: ${APIVERSION}" 354 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
194} 355}
195 356
196vdr-plugin_src_unpack() { 357vdr-plugin_src_unpack() {
197 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 358 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
198 eerror "Wrong use of vdr-plugin.eclass." 359 eerror "Wrong use of vdr-plugin.eclass."
210 vdr-plugin_src_unpack add_local_patch patchmakefile i18n 371 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
211 ;; 372 ;;
212 unpack) 373 unpack)
213 base_src_unpack 374 base_src_unpack
214 ;; 375 ;;
376 add_local_patch)
377 cd "${S}" || die "Could not change to plugin-source-directory!"
378 vdr_add_local_patch
379 ;;
215 patchmakefile) 380 patchmakefile)
216 if ! cd ${S}; then
217 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
218 ewarn "Perhaps you find one among these:"
219 cd "${WORKDIR}"
220 ewarn "$(/bin/ls -1 ${WORKDIR})"
221 die "Could not change to plugin-source-directory!" 381 cd "${S}" || die "Could not change to plugin-source-directory!"
222 fi 382 vdr_patchmakefile
223
224 einfo "Patching Makefile"
225 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
226 cp Makefile "${WORKDIR}"/Makefile.before
227
228 sed -i Makefile \
229 -e '1i\#Makefile was patched by vdr-plugin.eclass'
230
231 ebegin " Setting Pathes"
232 sed -i Makefile \
233 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
234 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
235 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
236 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
237 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
238 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
239 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
240 eend $?
241
242 ebegin " Converting to APIVERSION"
243 sed -i Makefile \
244 -e 's:^APIVERSION = :APIVERSION ?= :' \
245 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
246 -e '2i\APIVERSION = '"${APIVERSION}"
247 eend $?
248
249 ebegin " Correcting Compile-Flags"
250 sed -i Makefile \
251 -e 's:^CXXFLAGS:#CXXFLAGS:' \
252 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
253 eend $?
254
255 ebegin " Disabling file stripping"
256 sed -i Makefile \
257 -e '/@.*strip/d' \
258 -e '/strip \$(LIBDIR)\/\$@/d' \
259 -e '/^STRIP =/d' \
260 -e '/@.*\$(STRIP)/d'
261 eend $?
262
263 # Use a file instead of an variable as single-stepping via ebuild
264 # destroys environment.
265 touch ${WORKDIR}/.vdr-plugin_makefile_patched
266 ;;
267 add_local_patch)
268 cd ${S}
269 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
270 echo
271 einfo "Applying local patches"
272 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
273 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
274 done
275 fi
276 ;; 383 ;;
277 i18n) 384 i18n)
278 cd ${S} 385 cd "${S}" || die "Could not change to plugin-source-directory!"
279 if [[ ${USE_GETTEXT} = 0 ]]; then 386 vdr_i18n
280 # Remove i18n Target if using older vdr 387 ;;
281 sed -i Makefile \
282 -e '/^all:/s/ i18n//'
283 elif [[ ${USE_GETTEXT} = 1 && ! -d po ]]; then
284 einfo "Converting translations to gettext"
285
286 local i18n_tool=/usr/share/vdr/bin/i18n-to-gettext.pl
287 if [[ ! -x ${i18n_tool} ]]; then
288 eerror "Missing ${i18n_tool}"
289 eerror "Please re-emerge vdr"
290 die "Missing ${i18n_tool}"
291 fi
292
293 # call i18n-to-gettext tool
294 # take all texts missing tr call into special file
295 ${i18n_tool} 2>/dev/null \
296 |sed -e '/^"/!d' \
297 -e '/^""$/d' \
298 -e 's/\(.*\)/trNOOP(\1)/' \
299 > dummy-translations-trNOOP.c
300
301 # if there were untranslated texts just run it again
302 # now the missing calls are listed in
303 # dummy-translations-trNOOP.c
304 if [[ -s dummy-translations-trNOOP.c ]]; then
305 ${i18n_tool} &>/dev/null
306 fi
307
308 # now use the modified Makefile
309 mv Makefile.new Makefile
310 fi
311 esac 388 esac
312 389
313 shift 390 shift
314 done 391 done
315}
316
317vdr-plugin_copy_source_tree() {
318 pushd . >/dev/null
319 cp -r ${S} ${T}/source-tree
320 cd ${T}/source-tree
321 cp "${WORKDIR}"/Makefile.before Makefile
322 sed -i Makefile \
323 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
324 -e 's:^CXXFLAGS:#CXXFLAGS:' \
325 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
326 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
327 popd >/dev/null
328}
329
330vdr-plugin_install_source_tree() {
331 einfo "Installing sources"
332 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
333 insinto ${destdir}-${PV}
334 doins -r ${T}/source-tree/*
335
336 dosym ${VDRPLUGIN}-${PV} ${destdir}
337} 392}
338 393
339vdr-plugin_src_compile() { 394vdr-plugin_src_compile() {
340 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 395 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
341 396
352 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 407 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
353 echo 408 echo
354 eerror "Please report this at bugs.gentoo.org." 409 eerror "Please report this at bugs.gentoo.org."
355 die "vdr-plugin_src_unpack not called!" 410 die "vdr-plugin_src_unpack not called!"
356 fi 411 fi
357 cd ${S} 412 cd "${S}"
358 413
359 emake ${BUILD_PARAMS} \ 414 emake ${BUILD_PARAMS} \
360 ${VDRPLUGIN_MAKE_TARGET:-all} \ 415 ${VDRPLUGIN_MAKE_TARGET:-all} \
361 LOCALEDIR="${TMP_LOCALE_DIR}" \ 416 LOCALEDIR="${TMP_LOCALE_DIR}" \
362 || die "emake failed" 417 || die "emake failed"
370vdr-plugin_src_install() { 425vdr-plugin_src_install() {
371 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 426 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
372 cd "${WORKDIR}" 427 cd "${WORKDIR}"
373 428
374 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 429 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
375 local mname=${P}-Makefile 430 local mname="${P}-Makefile"
376 cp "${S}"/Makefile ${mname}.patched 431 cp "${S}"/Makefile "${mname}.patched"
377 cp Makefile.before ${mname}.before 432 cp Makefile.before "${mname}.before"
378 433
379 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 434 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
380 435
381 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 436 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
382 doins ${mname}.diff 437 doins "${mname}.diff"
383 438
384 insinto "/usr/share/vdr/maintainer-data/makefile-before" 439 insinto "/usr/share/vdr/maintainer-data/makefile-before"
385 doins ${mname}.before 440 doins "${mname}.before"
386 441
387 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 442 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
388 doins ${mname}.patched 443 doins "${mname}.patched"
389 444
390 fi 445 fi
391 446
392 cd "${S}" 447 cd "${S}"
393 insinto "${VDR_PLUGIN_DIR}" 448 insinto "${VDR_PLUGIN_DIR}"
394 doins libvdr-*.so.* 449 doins libvdr-*.so.*
395 450
396 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 451 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
397 einfo "Installing locales" 452 einfo "Installing locales"
398 cd "${TMP_LOCALE_DIR}" 453 cd "${TMP_LOCALE_DIR}"
399 insinto "${LOCDIR}" 454 insinto "${LOCDIR}"
400 doins -r * 455 doins -r *
401 fi 456 fi
425 create_header_checksum_file 480 create_header_checksum_file
426 create_plugindb_file 481 create_plugindb_file
427} 482}
428 483
429vdr-plugin_pkg_postinst() { 484vdr-plugin_pkg_postinst() {
430 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 485 vdr-plugin_print_enable_command
431 update_vdrplugindb 486
432 fi
433 elog
434 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
435 elog "To activate execute the following command:"
436 elog
437 elog " emerge --config ${PN}"
438 elog
439 if [[ -n "${VDR_CONFD_FILE}" ]]; then 487 if [[ -n "${VDR_CONFD_FILE}" ]]; then
440 elog "And have a look at the config-file" 488 elog "Please have a look at the config-file"
441 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 489 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
442 elog 490 elog
443 fi 491 fi
444} 492}
445 493
446vdr-plugin_pkg_postrm() { 494vdr-plugin_pkg_postrm() {
447 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
448 remove_vdrplugindb
449 fi
450 delete_orphan_plugindb_file 495 delete_orphan_plugindb_file
451} 496}
452 497
453vdr-plugin_pkg_config_final() {
454 diff ${conf_orig} ${conf}
455 rm ${conf_orig}
456}
457
458vdr-plugin_pkg_config_old() {
459 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
460 if [[ -z "${INSTALLPLUGIN}" ]]; then
461 INSTALLPLUGIN="${VDRPLUGIN}"
462 fi
463 # First test if plugin is already inside PLUGINS
464 local conf=/etc/conf.d/vdr
465 conf_orig=${conf}.before_emerge_config
466 cp ${conf} ${conf_orig}
467
468 elog "Reading ${conf}"
469 if ! grep -q "^PLUGINS=" ${conf}; then
470 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
471 if [[ -n "${LINE}" ]]; then
472 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
473 else
474 echo 'PLUGINS=""' >> ${conf}
475 fi
476 unset LINE
477 fi
478
479 unset PLUGINS
480 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
481
482 active=0
483 for p in ${PLUGINS}; do
484 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
485 active=1
486 break;
487 fi
488 done
489
490 if [[ "${active}" == "1" ]]; then
491 elog "${INSTALLPLUGIN} already activated"
492 echo
493 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
494 if [[ "${answer}" != "yes" ]]; then
495 elog "aborted"
496 return
497 fi
498 elog "Removing ${INSTALLPLUGIN} from active plugins."
499 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
500 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
501 -e ${LINE}'s/ \( \)*/ /g' \
502 -e ${LINE}'s/ "/"/g' \
503 -e ${LINE}'s/" /"/g'
504
505 vdr-plugin_pkg_config_final
506 return
507 fi
508
509
510 elog "Adding ${INSTALLPLUGIN} to active plugins."
511 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
512 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
513 -e ${LINE}'s/ \( \)*/ /g' \
514 -e ${LINE}'s/ "/"/g' \
515 -e ${LINE}'s/" /"/g'
516
517 vdr-plugin_pkg_config_final
518}
519
520vdr-plugin_pkg_config_new() {
521 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
522 if [[ -z "${INSTALLPLUGIN}" ]]; then
523 INSTALLPLUGIN="${VDRPLUGIN}"
524 fi
525
526 active=0
527 # First test if plugin is already inside PLUGINS
528 local conf=/etc/conf.d/vdr.plugins
529 exec 3<${conf}
530 while read -u 3 line; do
531 [[ ${line} == "" ]] && continue
532 [[ ${line:0:1} == "#" ]] && continue
533 set -- ${line}
534 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
535 done
536 exec 3<&-
537
538 if [[ $active == 0 ]]; then
539 elog "Adding ${INSTALLPLUGIN} to active plugins."
540
541 # The pure edit process.
542 echo "${INSTALLPLUGIN}" >> "${conf}"
543 else
544 elog "${INSTALLPLUGIN} already activated"
545 echo
546 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
547 if [[ "${answer}" != "yes" ]]; then
548 elog "aborted"
549 return
550 fi
551 elog "Removing ${INSTALLPLUGIN} from active plugins."
552
553 # The pure edit process
554 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
555 fi
556}
557
558vdr-plugin_pkg_config() { 498vdr-plugin_pkg_config() {
559 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 499 ewarn "emerge --config ${PN} is no longer supported"
560 vdr-plugin_pkg_config_new 500 vdr-plugin_print_enable_command
561 else
562 vdr-plugin_pkg_config_old
563 fi
564}
565
566fix_vdr_libsi_include()
567{
568 einfo "Fixing include of libsi-headers"
569 local f
570 for f; do
571 sed -i "${f}" \
572 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
573 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
574 done
575} 501}
576 502
577EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 503EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.59

  ViewVC Help
Powered by ViewVC 1.1.20